SystemOrganization addCategory: #'Ocompletion-ECView'!

SystemWindow subclass: #ECHelpMorph
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ocompletion-ECView'!

!ECHelpMorph commentStamp: '<historical>' prior: 0!
I am a system window that displays the keybindings of eCompletion. The text is static and generated in the class methods.!

!ECHelpMorph class methodsFor: 'private' stamp: 'bar 3/30/2006 14:27'!
explanationAttributes
	^{TextIndent spaceUsed; tabs: 2}! !

!ECHelpMorph class methodsFor: 'help-text' stamp: 'DamienCassou 12/23/2009 16:25'!
helpText
	| stream |
	stream := TextStream on: Text new.
	self section: 'character completion' on: stream.
	self
		shortcut: 'works on'
		text: ' [] {} () <> '''' ""'
		on: stream.
	self
		shortcut: 'usage 1'
		text: 'enter open character - closing character is entered as well'
		on: stream.
	self
		shortcut: 'usage 2'
		text: 'select some text, enter a smart character and the selected text get surrounded by the opening and closing character.'
		on: stream.
	self section: 'open/close menu' on: stream.
	self
		shortcut: 'ctrl-space or tab'
		text: 'open the completion menu'
		on: stream.
	self
		shortcut: 'ESC'
		text: 'close menu'
		on: stream.
	self
		shortcut: '?, ctl-h'
		text: 'open this help'
		on: stream.
	self section: 'menu navigation' on: stream.
	self
		shortcut: 'Arrows up/down'
		text: 'move the selection up and down'
		on: stream.
	self
		shortcut: 'Page up/down'
		text: 'page up and down'
		on: stream.
	self
		shortcut: 'Home/End'
		text: 'move to first or last page of the menu'
		on: stream.
	self section: 'show details and browse' on: stream.
	self
		shortcut: 'right arrow (detail closed)'
		text: 'show details about the selected item. This may be the type of the variable, the source of a method or the implementors of the selector.'
		on: stream.
	self
		shortcut: 'right arrow (detail open)'
		text: 'open a new browser for the selected item.'
		on: stream.
	self
		shortcut: 'left arrow'
		text: 'close the details'
		on: stream.
	self section: 'changing menu contents' on: stream.
	self
		shortcut: 'ctrl-u'
		text: 'switch to untyped mode in a typed menu'
		on: stream.
	self
		shortcut: 'ctrl-t'
		text: 'filter out methods of class Object in a typed menu. press again to make the reappear.'
		on: stream.
	self
		shortcut: 'alphanumeric character'
		text: 'filter the menu to the given input'
		on: stream.
	self
		shortcut: 'backspace'
		text: 'delete an input character, adjust menu to the new input.'
		on: stream.
	self section: 'inserting completion' on: stream.
	self
		shortcut: 'ctrl-space or tab'
		text: 'close the menu and insert selected completion. if there only one item left in the menu this done automaticly.'
		on: stream.
	^ stream contents! !

!ECHelpMorph class methodsFor: 'private' stamp: 'bar 3/12/2006 12:26'!
section: aString on: aTextStream 
	aTextStream
		withAttributes: self sectionAttributes
		do: [aTextStream nextPutAll: aString].
	aTextStream cr! !

!ECHelpMorph class methodsFor: 'private' stamp: 'bar 3/12/2006 12:14'!
sectionAttributes
	^ {TextEmphasis bold}! !

!ECHelpMorph class methodsFor: 'private' stamp: 'bar 3/12/2006 14:30'!
shortcut: aString text: secondString on: aTextStream 
	aTextStream
		withAttributes: self shortcutAttributes
		do: [aTextStream nextPutAll: aString;
				 cr].
	aTextStream
		withAttributes: self explanationAttributes
		do: [aTextStream nextPutAll: secondString;
				 cr].
! !

!ECHelpMorph class methodsFor: 'private' stamp: 'bar 3/30/2006 14:27'!
shortcutAttributes
	^ {TextIndent spaceUsed; tabs: 1. TextEmphasis italic }! !

!ECHelpMorph methodsFor: 'initialize' stamp: 'bar 3/12/2006 14:26'!
contents
	^self class helpText ! !

!ECHelpMorph methodsFor: 'initialize' stamp: 'EduardoEscobar 1/10/2012 22:18'!
defaultColor
	"answer the default color/fill style for the receiver."
	^ ECMenuMorph backgroundColor! !

!ECHelpMorph methodsFor: 'initialize' stamp: 'bar 3/20/2006 15:35'!
initialize
	"textMorph _ TextMorph new contents: self class helpText;
	yourself.
	self addMorph: textMorph"
	| text |
	super initialize.
	self setLabel: 'eCompletion Keyboard Help'.
	"self height: ECMenuMorph itemHeight * 60."
	text := PluggableTextMorph
				on: self
				text: #contents
				accept: nil
				readSelection: nil
				menu: nil.
	self
		addMorph: text
		frame: (0 @ 0 corner: 1.0 @ 1.0).
	text lock.! !

Object subclass: #ECController
	instanceVariableNames: 'model menuMorph editor context oppositeChar caret inverseMapping'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ocompletion-ECView'!

!ECController commentStamp: '<historical>' prior: 0!
I live as an instance variable in a Browser, Debugger, Workspace or other window. I'm the glue between all participants of the completion system. I create the ECContext and pass myself to the ECMenuMorph. I process the keyboard events and pass them to the ECMenuMorph or close the morph if needed.!

!ECController class methodsFor: 'testing' stamp: 'lr 5/11/2010 12:54'!
allowModel: aModel 
	^ aModel respondsTo: #completionController! !

!ECController class methodsFor: 'instance creation' stamp: 'bar 12/13/2004 12:05'!
model: aStringHolder 
	^self new setModel: aStringHolder! !

!ECController methodsFor: 'accessing' stamp: 'bar 12/16/2004 11:13'!
additionals
	^ nil! !

!ECController methodsFor: 'menu morph' stamp: 'ul 2/9/2011 03:53'!
closeMenu

	menuMorph ifNotNil: [
		menuMorph delete.
		menuMorph := nil ]! !

!ECController methodsFor: 'accessing' stamp: 'bar 12/13/2004 12:08'!
context
	^context! !

!ECController methodsFor: 'accessing' stamp: 'ul 2/9/2011 02:56'!
contextClass

	^ECContext! !

!ECController methodsFor: 'accessing' stamp: 'ul 12/6/2010 22:06'!
editor

	^editor ifNotNil: [ editor at: 1 ]
! !

!ECController methodsFor: 'accessing' stamp: 'ul 12/6/2010 22:06'!
editor: theEditor

	(editor ifNil: [ editor := WeakArray new: 1 ])
		at: 1 put: theEditor
! !

!ECController methodsFor: 'type guessing' stamp: 'ul 10/29/2010 05:54'!
guessTypeFor: aString 

	^self model ifNotNil: [ :theModel |
		theModel guessTypeForName: aString ]! !

!ECController methodsFor: 'keyboard' stamp: 'ul 2/8/2011 21:25'!
handleKeystrokeAfter: aKeyboardEvent editor: anEditor 
	(anEditor isNil or:[self isMenuOpen not]) ifTrue:[^self].
	self setModel: anEditor model.
			context narrowWith: anEditor wordAtCaret.
			menuMorph narrowCompletion! !

!ECController methodsFor: 'keyboard' stamp: 'EduardoEscobar 1/10/2012 22:05'!
handleKeystrokeBefore: aKeyboardEvent editor: anEditor 
	"I return a boolean. true when I have handled the event and no futher processing is needed by the caller."
	
	| theEditor keyValue controlKeyPressed isSpaceKey |
	self editor: anEditor. 
	theEditor := self editor.
	self setModel: theEditor model.
	keyValue := aKeyboardEvent keyValue.
	controlKeyPressed := aKeyboardEvent controlKeyPressed.
	isSpaceKey := #(0 32 ) includes: keyValue.
	"Ctrl-Space or Tab for open"
	self isMenuOpen
		ifFalse: [(isSpaceKey & controlKeyPressed
					or: [keyValue = 9
							and: [theEditor isCaretBehindChar
									and: [controlKeyPressed not]]])
				ifTrue: [self openMenuFor: theEditor.
					^ true]
				ifFalse: [(self smartInput: keyValue)
						ifNotNil: [^ true]].
			^ false].
	"Home"
	keyValue = 1
		ifTrue: [menuMorph home.
			^ true].
	"End"
	(keyValue = 4
			and: [controlKeyPressed not])
		ifTrue: [menuMorph end. 
			^ true].
	(keyValue = 8 and:[controlKeyPressed ]) ifTrue:[menuMorph help. ^true].
	"Right-Arrow"
	keyValue = 29
		ifTrue: [menuMorph showDetail.
			^ true].
	"Left Arrow"
	keyValue = 28
		ifTrue: [menuMorph hideDetail.
			^ true].
	"Arrow up"
	keyValue = 30
		ifTrue: [menuMorph moveUp.
			^ true].
	"Arrow down"
	keyValue = 31
		ifTrue: [menuMorph moveDown.
			^ true].
	"Page up"
	keyValue = 11
		ifTrue: [menuMorph pageUp.
			^ true].
	"Page down"
	keyValue = 12
		ifTrue: [menuMorph pageDown.
			^ true].
	"Tab or Ctrl-Space"
	(keyValue = 13
			or: [isSpaceKey & controlKeyPressed
					or: [keyValue = 9]])
		ifTrue: [menuMorph insertSelected
				ifTrue: [^ true]].
	"Ctrl-u"
	keyValue = 21 & controlKeyPressed
		ifTrue: [menuMorph switchToUntyped.
			^ true].
	"Crtl-t"
	(keyValue = 20
			and: [controlKeyPressed])
		ifTrue: [menuMorph expand.
			^ true].
	"All keys but the alphanumeric chars (without command and control ) 
	and the backspace key do close the menu"
	keyValue = 8
		ifTrue: [theEditor isCaretBehindChar not
				ifTrue: [self closeMenu].
			^ false].
	(controlKeyPressed not & aKeyboardEvent commandKeyPressed not
			and: [aKeyboardEvent keyCharacter isAlphaNumeric])
		ifFalse: [self closeMenu.
			^ keyValue = 27].
	^ false! !

!ECController methodsFor: 'keyboard' stamp: 'klub 11/23/2010 13:01'!
invalidateEditorMorph
	
	| theEditor |
	theEditor := self editor ifNil: [ ^self ].
	theEditor morph invalidRect: theEditor morph bounds.
! !

!ECController methodsFor: 'menu morph' stamp: 'RomainRobbes 10/19/2009 16:58'!
isMenuOpen
	^menuMorph notNil and: [menuMorph itemsCount > 0 ifTrue: [true] ifFalse: [self closeMenu. false]]
! !

!ECController methodsFor: 'menu morph' stamp: 'damiencassou 7/29/2009 15:25'!
menuClosed
	menuMorph := nil.
	context := nil.! !

!ECController methodsFor: 'accessing' stamp: 'ul 2/9/2011 02:56'!
menuMorph

	^ECMenuMorph! !

!ECController methodsFor: 'accessing' stamp: 'RomainRobbes 12/26/2009 19:12'!
model
	^model isArray ifTrue: [model first] ifFalse: [model]! !

!ECController methodsFor: 'menu morph' stamp: 'BenjaminVanRyseghem 5/16/2011 16:20'!
openMenuFor: anEditor

	| theMenu class |

	"Now I check if the method exist, it prevent for crashing each time a key is pressed"
	(self model class respondsTo: #selectedClassOrMetaClass)
		ifTrue: [ class := self model selectedClassOrMetaClass ]
		ifFalse: [ class := nil ].
		
	self closeMenu.
	context := self contextClass 
		controller: self
		class: class
		source: anEditor text string
		position: anEditor startIndex - 1.
	self editor: anEditor.
	theMenu := self menuMorph
		controller: self
		position: (anEditor selectionPosition: context completionToken).
	theMenu isClosed ifFalse: [ menuMorph := theMenu ]! !

!ECController methodsFor: 'initialize-release' stamp: 'RomainRobbes 12/26/2009 19:12'!
setModel: aStringHolder 
	model := WeakArray with: aStringHolder! !

!ECController methodsFor: 'keyboard' stamp: 'ul 2/8/2011 23:08'!
smartBackspace

	| opposite theEditor |
	theEditor := self editor ifNil: [ ^nil ].
	theEditor hasSelection ifTrue: [ ^nil ].
	opposite := ECPreferences smartCharactersMapping
		at: (theEditor text
			at: theEditor startIndex - 1
			ifAbsent: [ ^ nil ])
		ifAbsent: [ ^ nil ].
	opposite = (theEditor text at: theEditor stopIndex ifAbsent: [ ^ nil ])
		ifFalse: [ ^ nil ].
	theEditor selectInvisiblyFrom: theEditor startIndex - 1 to: theEditor stopIndex.
	theEditor zapSelectionWith: String new.
	self invalidateEditorMorph.
	^ true
	
! !

!ECController methodsFor: 'keyboard' stamp: 'ul 2/9/2011 15:03'!
smartCharacter: aCharacter

	| theEditor opposite previous next |
	theEditor := self editor ifNil: [ ^nil ].
	theEditor hasSelection ifTrue: [
		opposite := ECPreferences smartCharactersMapping at: aCharacter ifAbsent: [ ^nil ].
		theEditor zapSelectionWith: aCharacter asString, theEditor selection, opposite asString.
		ECPreferences keepSelectionAfterAddingSmartCharacters 
			ifTrue: [ theEditor selectFrom: theEditor startIndex + 1 to: theEditor stopIndex - 2 ]
			ifFalse: [ theEditor selectFrom: theEditor stopIndex to: theEditor stopIndex - 1 ].
		self invalidateEditorMorph.
		^ true ].	
	opposite := ECPreferences smartCharactersMapping at: aCharacter ifAbsent: [
		"If this is not a closing pair for a smart character then do nothing."
		(ECPreferences smartCharactersMapping includes: aCharacter) ifFalse: [ ^nil ].
		theEditor blinkPrevParen: aCharacter.
		(theEditor text at: theEditor startIndex ifAbsent: [ ^ nil ]) = aCharacter
			ifFalse: [ ^ nil ].
		theEditor selectFrom: theEditor startIndex + 1 to: theEditor startIndex.
		self invalidateEditorMorph.
		^ true ].
	previous := theEditor text at: theEditor startIndex - 1 ifAbsent: [ Character space ].
	next := theEditor text at: theEditor startIndex ifAbsent: [ Character space ].
	(previous isSeparator or: [ next isSeparator ])
		ifFalse: [ ^ nil ].
	(opposite = aCharacter and: [ next = aCharacter ]) ifTrue: [
		theEditor selectFrom: theEditor startIndex + 1 to: theEditor startIndex.
		self invalidateEditorMorph.
		^ true ].
	theEditor zapSelectionWith: (String with: aCharacter with: opposite).
	theEditor selectFrom: theEditor startIndex + 1 to: theEditor startIndex.
	self invalidateEditorMorph.
	^ true! !

!ECController methodsFor: 'keyboard' stamp: 'ul 2/8/2011 23:07'!
smartInput: anInteger 

	ECPreferences smartCharacters ifFalse: [ ^nil ].
	^ anInteger = 8
		ifTrue: [ self smartBackspace ]
		ifFalse:  [ self smartCharacter: anInteger asCharacter ]! !

!ECController methodsFor: 'updating' stamp: 'ul 4/21/2011 03:12'!
update: aSymbol
	"Close the menu when the contents of the model changes."

	aSymbol == #contents ifTrue: [ self closeMenu ].
	^super update: aSymbol
	

	! !

!ECController methodsFor: 'accessing' stamp: 'bar 12/15/2004 09:23'!
workspace
	^nil! !

ECController subclass: #ECWorkspaceController
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ocompletion-ECView'!

!ECWorkspaceController commentStamp: '<historical>' prior: 0!
I'm a specialized controller, that works with Workspaces.!

!ECWorkspaceController methodsFor: 'accessing' stamp: 'bar 12/16/2004 11:14'!
additionals
	^ self workspace completionAdditionals! !

!ECWorkspaceController methodsFor: 'accessing' stamp: 'RomainRobbes 12/26/2009 19:10'!
workspace
	^self model! !

BorderedMorph subclass: #ECDetailMorph
	instanceVariableNames: 'title description arrowPosition label itemHeight'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ocompletion-ECView'!

!ECDetailMorph commentStamp: '<historical>' prior: 0!
I display some detail information for a selected ECEntry in the ECMenuMorph.
The content I show, is provided by an ECDetailContentProvider subclass. 
!

!ECDetailMorph class methodsFor: 'as yet unclassified' stamp: 'bar 3/3/2006 16:14'!
height
	^ ECMenuMorph itemHeight * 15.5! !

!ECDetailMorph class methodsFor: 'as yet unclassified' stamp: 'bar 3/3/2006 22:45'!
width
	^ ECMenuMorph itemWidth * 2.0! !

!ECDetailMorph methodsFor: 'drawing' stamp: 'EduardoEscobar 1/10/2012 22:06'!
bounds
	"Return the bounds of this morph."
	^ super bounds topLeft extent: self class width @ self class height! !

!ECDetailMorph methodsFor: 'drawing' stamp: 'DamienCassou 12/23/2009 16:25'!
contentBounds
	| factor rectangle |
	factor := ECMenuMorph messageHeight.
	rectangle := self bounds top: self bounds top + 3.
	rectangle := rectangle left: rectangle left + (factor * 2.0).
	rectangle := rectangle bottom: rectangle bottom - factor. 
	^ rectangle! !

!ECDetailMorph methodsFor: 'drawing' stamp: 'EduardoEscobar 1/10/2012 22:14'!
defaultColor
	"answer the default color/fill style for the receiver."
	^ ECMenuMorph backgroundColor. ! !

!ECDetailMorph methodsFor: 'accessing' stamp: 'MAD 10/8/2009 14:19'!
descriptionBounds
	^ self contentBounds top: self contentBounds top + ECMenuMorph messageHeight + ECMenuMorph titleHeight ! !

!ECDetailMorph methodsFor: 'drawing' stamp: 'MAD 10/8/2009 14:01'!
drawArrowOn: aCanvas 
	| point factor poligon |
	factor := self itemHeight.
	point := arrowPosition.
	poligon := OrderedCollection new.
	poligon add: point.
	poligon add: (point := point translateBy: factor / 2 @ 0).
	poligon add: (point := point translateBy: 0 @ (factor * -0.5)).
	poligon add: (point := point translateBy: factor @ factor).
	poligon add: (point := point translateBy: factor * -1 @ factor).
	poligon add: (point := point translateBy: 0 @ (factor * -0.5)).
	poligon add: (point := point translateBy: factor * -0.5 @ 0).
	aCanvas drawPolygon: poligon fillStyle: ECMenuMorph scrollColor! !

!ECDetailMorph methodsFor: 'drawing' stamp: 'DamienCassou 12/23/2009 16:25'!
drawMessageOn: aCanvas 
	|  rectangle width browseMessage |
	rectangle := self bounds top: self bounds bottom - ECMenuMorph messageHeight.
	rectangle := rectangle left: self contentBounds left.
	aCanvas
		line: rectangle topLeft
		to: rectangle topRight - (1@0)
		color: Color gray.
	rectangle := rectangle insetBy: 1.
	aCanvas
		drawString: '<- close detail'
		in: rectangle
		font: ECMenuMorph messageFont
		color: Color gray.
	browseMessage := 'browse ->'.
	width := ECMenuMorph messageFont widthOfString: browseMessage .
	aCanvas
		drawString: browseMessage
		in: (rectangle left: rectangle right - width)
		font: ECMenuMorph messageFont
		color: Color gray! !

!ECDetailMorph methodsFor: 'drawing' stamp: 'bar 3/2/2006 21:16'!
drawOn: aCanvas 
	super drawOn: aCanvas.
	arrowPosition ifNotNil: [
	self drawArrowOn: aCanvas.
	self drawMessageOn: aCanvas]! !

!ECDetailMorph methodsFor: 'accessing' stamp: 'bar 3/20/2006 15:33'!
entryDescription: anECEntryDescription 
	| categoryContents entryDescription |
	entryDescription := anECEntryDescription.
	title
		contents: (entryDescription title
				ifNil: [description bounds: self titleBounds.
					String new]
				ifNotNil: [description bounds: self descriptionBounds.
					entryDescription title]).
	description contentsWrapped: entryDescription description.
	categoryContents := entryDescription label.
	label contents: categoryContents! !

!ECDetailMorph methodsFor: 'accessing' stamp: 'EduardoEscobar 1/10/2012 22:15'!
initialize
	"initialize the state of the receiver."
	| childBounds |
	super initialize.
	self setBorderWidth: 1 borderColor: Color gray.
	childBounds := self contentBounds.
	label := StringMorph contents: '' font: ECMenuMorph messageFont.
	label bounds: childBounds.
	self addMorph: label.
	title := StringMorph contents: '' font: ECMenuMorph titleFont.
	title bounds: self titleBounds.
	self addMorph: title.
	description := TextMorph new.
	description autoFit: false.
	description bounds: self descriptionBounds.
	description borderWidth: 0.
	self addMorph: description! !

!ECDetailMorph methodsFor: 'accessing' stamp: 'MAD 10/8/2009 14:00'!
itemHeight
	^ itemHeight ifNil: [itemHeight := ECMenuMorph itemHeight]! !

!ECDetailMorph methodsFor: 'drawing' stamp: 'MAD 10/8/2009 14:01'!
position: aPoint menuWidth: anInteger 
	| y x |
	arrowPosition := aPoint.
	y := aPoint y + self class height.
	y := y > Display height
				ifTrue: [Display height - self class height]
				ifFalse: [aPoint y - self itemHeight].
	x := aPoint x.
	x := x + self class width > Display width
				ifTrue: [arrowPosition := (self positionOnLeft: anInteger) @ aPoint y.
					arrowPosition x]
				ifFalse: [x].
	self position: x @ y! !

!ECDetailMorph methodsFor: 'private' stamp: 'MAD 10/8/2009 11:05'!
positionOnLeft: anInteger 
	"tightened up the positioning. MAD"
	^ arrowPosition x - self class width - anInteger + 2! !

!ECDetailMorph methodsFor: 'accessing' stamp: 'MAD 10/8/2009 14:16'!
titleBounds
	^ self contentBounds top: self contentBounds top + ECMenuMorph messageHeight! !

BorderedMorph subclass: #ECMenuMorph
	instanceVariableNames: 'selected firstVisible titleStringMorph controller context pageHeight itemHeight detailMorph detailPosition'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Ocompletion-ECView'!

ECMenuMorph class
	instanceVariableNames: 'messageFont titleFont'!

!ECMenuMorph commentStamp: '<historical>' prior: 0!
I show the possible completions in a menu like appearance. The user may choose an entry from my list and complete the word he was typing in the editor. I'm showed with the Tab key and will be deleted when with ESC key or when a successful completion occurs. The following keystrokes are supported:

Ctrl-Space or Tab: Open a new morph. Tab requires at least one character in front of the cursor. When already open complete the selected entry. 
Esc: Close me
Ctrl+u: Change to untyped mode, so I show all selectors of all classes in the system and the variables that are accessible to the current context.
Arrow Up: Move one entry up.
Arrow Down: Move one entry down
Enter: (like Ctrl-Space and Tab): Complete with the selected item and close the morph
any letter or digit: Narrow the completion further
Ctrl+t: Toggle the expand flag. When expand is disabled, you don't see selectors belonging to Object and ProtoObject. 

!

ECMenuMorph class
	instanceVariableNames: 'messageFont titleFont'!

!ECMenuMorph class methodsFor: 'preferences' stamp: 'RomainRobbes 10/19/2009 19:26'!
backgroundColor
	"ECMenuMorph backgroundColor"
	^ Color gray: 0.95! !

!ECMenuMorph class methodsFor: 'preferences' stamp: 'MAD 10/8/2009 10:57'!
borderColor
	^ Color gray! !

!ECMenuMorph class methodsFor: 'instance creation' stamp: 'bar 12/13/2004 11:34'!
controller: aECController position: aPoint 
	| newObject |
	newObject := self new.
	newObject setController: aECController position: aPoint.
	^ newObject! !

!ECMenuMorph class methodsFor: 'preferences' stamp: 'MAD 10/7/2009 12:17'!
convertToSHSymbol: aSymbol 
	^ (SHTextStylerST80 new attributesFor: aSymbol)
			isNil
				ifTrue: [#default]
				ifFalse: [aSymbol]
! !

!ECMenuMorph class methodsFor: 'preferences' stamp: 'lr 7/4/2009 10:42'!
helpText
	| text |
	text := TextStream new.
	text 
		withAttribute: TextEmphasis bold
		do: [ text nextPut: 'hello' ] text! !

!ECMenuMorph class methodsFor: 'preferences' stamp: 'MAD 10/8/2009 14:04'!
itemHeight
	"height must be forced to be even to allow the detail arrow to be drawn correctly"	
	^ (self listFont height + 2) roundUpTo: 2"14".! !

!ECMenuMorph class methodsFor: 'preferences' stamp: 'MAD 10/8/2009 11:40'!
itemWidth

	^ ECMenuMorph listFont widthOfString:'SphinxOfBlackQuartzHearMyVow1234567890' "212."! !

!ECMenuMorph class methodsFor: 'preferences' stamp: 'ul 10/27/2010 03:13'!
listFont

	^ECPreferences listFont! !

!ECMenuMorph class methodsFor: 'preferences' stamp: 'bar 10/17/2004 15:16'!
maxLength

	"CompletionMorph maxLength "
	
	^30.! !

!ECMenuMorph class methodsFor: 'preferences' stamp: 'MAD 10/7/2009 12:01'!
messageFont
	"hard code a strike font for tidiness"
	^ StrikeFont familyName: 'Accujen' pointSize: 10 emphasized: 0.
! !

!ECMenuMorph class methodsFor: 'preferences' stamp: 'MAD 10/8/2009 13:49'!
messageHeight
	^ self messageFont height + 2! !

!ECMenuMorph class methodsFor: 'preferences' stamp: 'bar 11/19/2004 20:53'!
scrollArrowSize
	^8! !

!ECMenuMorph class methodsFor: 'preferences' stamp: 'ul 10/27/2010 03:16'!
scrollColor

	^ECPreferences menuSelectionColor ! !

!ECMenuMorph class methodsFor: 'preferences' stamp: 'lr 7/4/2009 10:42'!
selectColorFor: aSymbol 
	| attribute |
	attribute := self convertToSHSymbol: aSymbol.
	^ (SHTextStylerST80 new attributesFor: attribute) first color! !

!ECMenuMorph class methodsFor: 'preferences' stamp: 'DamienCassou 12/23/2009 16:25'!
selectFontFor: aSymbol 
	| emphasized attributes |
	attributes := SHTextStylerST80 new
				attributesFor: (self convertToSHSymbol: aSymbol).
	emphasized := attributes size > 1
				ifTrue: [attributes second emphasisCode]
				ifFalse: [0]. 
	^ self listFont emphasized: emphasized! !

!ECMenuMorph class methodsFor: 'preferences' stamp: 'MAD 10/7/2009 11:48'!
titleFont
	"use a strikefont, as TT fonts don't rotate nicely. Don't cache, as it gets manipulated later"
	^ StrikeFont familyName: 'Accujen' pointSize: 12 emphasized: 1! !

!ECMenuMorph class methodsFor: 'preferences' stamp: 'MAD 10/8/2009 14:19'!
titleHeight
	^ self titleFont height + 2! !

!ECMenuMorph methodsFor: 'actions' stamp: 'bar 3/3/2006 16:28'!
browse
	(self selectedEntry browseWith: context)
		ifTrue: [controller closeMenu]! !

!ECMenuMorph methodsFor: 'initialization' stamp: 'MAD 10/8/2009 14:06'!
createTitle
	| transformationMorph titleString |
	titleString := context model title.
	titleString
		ifNil: [^ self].
	transformationMorph := TransformationMorph new.
	self addMorph: transformationMorph.
	titleStringMorph := StringMorph new.
	titleStringMorph font: self class titleFont.
	transformationMorph addMorph: titleStringMorph.
	transformationMorph rotationDegrees: -90.0.
	titleStringMorph contents: titleString.
	transformationMorph topLeft: (self topLeft + (0@12))! !

!ECMenuMorph methodsFor: 'paging' stamp: 'bar 2/21/2006 21:32'!
currentPage
	^(self selected - 1 // self pageHeight ) + 1.! !

!ECMenuMorph methodsFor: 'private' stamp: 'EduardoEscobar 1/10/2012 22:19'!
delete
	"Remove the receiver as a submorph of its owner and make its new owner be nil."
	super delete.
	controller menuClosed! !

!ECMenuMorph methodsFor: 'drawing' stamp: 'MAD 10/7/2009 12:39'!
detailMessage
	^ detailMorph
		ifNil: [self helpText, ' | -> open detail']
		ifNotNil: [self helpText, ' | <- close detail']! !

!ECMenuMorph methodsFor: 'accessing' stamp: 'bar 3/12/2006 10:46'!
detailPosition: aPoint 
	detailPosition := aPoint.
	self triggerEvent: #positionChanged! !

!ECMenuMorph methodsFor: 'drawing' stamp: 'lr 7/4/2009 10:42'!
drawBottomScrollArrowOn: aCanvas 
	| aPoligon point arrowHeight |
	point := self bounds bottomLeft translateBy: 6 @ -12.
	arrowHeight := self class scrollArrowSize.
	aPoligon := Array 
		with: point
		with: (point translateBy: arrowHeight @ 0)
		with: (point translateBy: (arrowHeight / 2) @ arrowHeight).
	aCanvas 
		drawPolygon: aPoligon
		fillStyle: self class scrollColor! !

!ECMenuMorph methodsFor: 'drawing' stamp: 'MAD 10/8/2009 14:07'!
drawMessageOn: aCanvas in: rectangle 
	self hasMessage ifFalse:[^self].
	context model isEmpty 
		ifFalse:[
			aCanvas
				line: rectangle topLeft + (0 @ 1)
				to: rectangle topRight + (0 @ 1)
				color: Color gray]. 
	self drawModelMessageOn: aCanvas in:rectangle.
	self drawPageCountMessageOn: aCanvas in: rectangle.! !

!ECMenuMorph methodsFor: 'drawing' stamp: 'DamienCassou 12/23/2009 16:25'!
drawModelMessageOn: aCanvas in: rectangle 
	| message |
	message := context model hasMessage
				ifTrue: [context model message, ' | ', self helpText]
				ifFalse: [self detailMessage].
	aCanvas
		drawString: message
		in: (rectangle insetBy: 1)
		font: self class messageFont
		color: Color gray! !

!ECMenuMorph methodsFor: 'drawing' stamp: 'DamienCassou 12/23/2009 16:25'!
drawOn: aCanvas 
	| rectangle model textColor |
	super drawOn: aCanvas.
	self drawTitleOn: aCanvas.
	rectangle := self bounds copy.
	rectangle bottom: rectangle top + self itemHeight.
	rectangle := rectangle left: rectangle left + 20.
	model := context model.
	self extent: self extent.
	self firstVisible > 1
		ifTrue: [self drawTopScrollArrowOn: aCanvas].
	self lastVisible ~= self itemsCount
		ifTrue: [self drawBottomScrollArrowOn: aCanvas].
	model notEmpty
		ifTrue: [self firstVisible
				to: self lastVisible
				do: [:index | 
					| symbol type string | 
					symbol := model entries at: index.
					string := symbol contents.
					type := symbol type.
					textColor := self selectColor: type.
					index = self selected
						ifTrue: [| rect | 
							rect := rectangle withBottom: rectangle top + self class itemHeight.
							aCanvas fillRectangle: rect color: self class scrollColor.
							self detailPosition: rect topRight - (1@0).
							textColor := textColor negated ].
					aCanvas
						drawString: string
						in: (rectangle insetBy: 1)
						font: (self selectFont: type)
						color: textColor.
					rectangle := self prepareRectForNextRow: rectangle]].
	"tweak rectangle to display message"
	rectangle := rectangle top: (self bounds bottom - self class messageHeight).
	self drawMessageOn: aCanvas in: rectangle! !

!ECMenuMorph methodsFor: 'drawing' stamp: 'DamienCassou 12/23/2009 16:25'!
drawPageCountMessageOn: aCanvas in: rectangle 
	| msg font msgWidth |
	self pageCount > 1 ifFalse:[^self].
	msg :=  self currentPage printString, '/', self pageCountString.
	font := self class messageFont.
	msgWidth := font widthOfString: msg.
	aCanvas 
		drawString: msg 
		in: (rectangle translateBy: (rectangle width - msgWidth - 3) @ 1)
		font: font
		color: Color gray. 
		! !

!ECMenuMorph methodsFor: 'drawing' stamp: 'bar 11/25/2004 09:48'!
drawTitleOn: aCanvas
	"| morphicTransform angle |
	angle := 90 degreesToRadians.
	morphicTransform := MorphicTransform offset: self position angle: angle scale: 1.0.
	aCanvas 
		transformBy: morphicTransform
		clippingTo: self owner innerBounds
		during: [:myCanvas | myCanvas drawString:'Ruben' at: self position font: self class titleFont color: Color blue]
		smoothing: 1."
		! !

!ECMenuMorph methodsFor: 'drawing' stamp: 'bar 11/19/2004 20:54'!
drawTopScrollArrowOn: aCanvas 
	| aPoligon point arrowHeight |
	arrowHeight := self class scrollArrowSize.
	point := self bounds topLeft translateBy: 6 @ 11.
	aPoligon := Array 
				with: point
				with: (point translateBy: arrowHeight @ 0)
				with: (point translateBy: arrowHeight / 2 @ arrowHeight negated).
	aCanvas 
		drawPolygon: aPoligon 
		fillStyle: self class scrollColor. 
	! !

!ECMenuMorph methodsFor: 'actions' stamp: 'bar 2/20/2006 17:26'!
end
	self gotoPage: self pageCount.
	self changed.! !

!ECMenuMorph methodsFor: 'actions' stamp: 'bar 12/16/2004 11:36'!
expand
	context model toggleExpand.
	self narrowCompletion! !

!ECMenuMorph methodsFor: 'private' stamp: 'bar 12/13/2004 11:46'!
firstVisible
	^firstVisible min: context model entryCount! !

!ECMenuMorph methodsFor: 'paging' stamp: 'bar 3/20/2006 16:05'!
gotoPage: anInteger
	| item |
	item := ((anInteger - 1) * self pageHeight) + 1. 
	item >= self itemsCount ifTrue:[^self].
	item < 1 ifTrue:[item := 1].
	firstVisible := item.
	self selected: firstVisible. 
	! !

!ECMenuMorph methodsFor: 'event handling' stamp: 'EduardoEscobar 1/10/2012 22:20'!
handleMouseEnter: anEvent
	"System level event handling."
	self activeHand newKeyboardFocus: controller editor morph.
	anEvent wasHandled: true. 
! !

!ECMenuMorph methodsFor: 'drawing' stamp: 'bar 3/12/2006 14:47'!
hasMessage
	^ true ! !

!ECMenuMorph methodsFor: 'accessing' stamp: 'DamienCassou 12/23/2009 16:25'!
height
	| height |
	height := self visible
				ifTrue: [Display height - self bounds topLeft y / self itemHeight - 1 min: self class maxLength]
				ifFalse: [self class maxLength].
	height asInteger isZero
		ifTrue: [^ 1]
		ifFalse: [^ height].! !

!ECMenuMorph methodsFor: 'actions' stamp: 'bar 3/12/2006 14:37'!
help
	ECHelpMorph new openInWorld! !

!ECMenuMorph methodsFor: 'drawing' stamp: 'MAD 10/7/2009 12:39'!
helpText
	^ '?=help'! !

!ECMenuMorph methodsFor: 'actions' stamp: 'lr 7/4/2009 10:42'!
hideDetail
	detailMorph ifNil: [ ^ self ].
	self removeMorph: detailMorph.
	detailMorph delete.
	detailMorph := nil.
	self changed! !

!ECMenuMorph methodsFor: 'actions' stamp: 'bar 2/20/2006 17:26'!
home
	self gotoPage: 1.
	self changed! !

!ECMenuMorph methodsFor: 'initialization' stamp: 'EduardoEscobar 1/10/2012 22:20'!
initialize
	"initialize the state of the receiver."
	super initialize.
	self color: self class backgroundColor.
	self setBorderWidth: 1 borderColor: self class borderColor.
	self
		when: #positionChanged
		send: #updateDetail
		to: self! !

!ECMenuMorph methodsFor: 'actions' stamp: 'kb 5/22/2011 15:08'!
insertCompletion: aString 
	| startIndex oldSelectionInterval editor |
	editor := controller editor.
	startIndex := editor startIndex.
	oldSelectionInterval := startIndex - context completionToken size to: startIndex - 1.
	editor 
		replace: oldSelectionInterval
		with: aString
		and: [ 
			editor selectAt: startIndex + (aString indexOf: Character space ifAbsent: [ aString size ])  - oldSelectionInterval size ].
	editor morph invalidRect: editor morph bounds ! !

!ECMenuMorph methodsFor: 'actions' stamp: 'bar 3/3/2006 16:30'!
insertSelected
	context model isEmpty ifTrue: [^ false].
	self insertCompletion: (context model completionAt: self selected).
	self delete.
	^ true! !

!ECMenuMorph methodsFor: 'private' stamp: 'bar 12/13/2004 16:14'!
isClosed
	^ owner isNil! !

!ECMenuMorph methodsFor: 'accessing' stamp: 'MAD 10/8/2009 14:03'!
itemHeight
	"cached to minimise recalculation"
	^ itemHeight ifNil: [itemHeight := self class itemHeight]! !

!ECMenuMorph methodsFor: 'private' stamp: 'bar 12/13/2004 11:47'!
itemsCount
	^context model entryCount! !

!ECMenuMorph methodsFor: 'private' stamp: 'RomainRobbes 8/2/2010 17:57'!
lastVisible

	^ (self firstVisible + self height - 1)  min: (self itemsCount).! !

!ECMenuMorph methodsFor: 'actions' stamp: 'bar 12/5/2004 22:23'!
moveDown
	self selected: self selected + 1.
	(self selected > self lastVisible
			and: [self selected <= self itemsCount])
		ifTrue: [firstVisible := firstVisible + 1].
	self changed! !

!ECMenuMorph methodsFor: 'actions' stamp: 'bar 12/13/2004 15:05'!
moveUp
	(self selected = 0
			and: [self firstVisible = 1])
		ifTrue: [^ self].
	self selected: self selected - 1.
	self selected < self firstVisible
		ifTrue: [firstVisible := firstVisible - 1].
	self changed. ! !

!ECMenuMorph methodsFor: 'actions' stamp: 'lr 7/4/2009 10:42'!
narrowCompletion
	| model |
	self selected: 0.
	firstVisible := 1.
	model := context model.
	model narrowWith: context completionToken.
	(model entries size = 1 and: [ context completionToken notEmpty ]) ifTrue: 
		[ self insertCompletion: (model completionAt: 1).
		self delete.
		^ false ].
	model notEmpty ifTrue: [ self selected: 1 ].
	self show.
	^ true! !

!ECMenuMorph methodsFor: 'paging' stamp: 'bar 3/30/2006 14:21'!
pageCount
	| count |
	self itemsCount == self pageHeight
		ifTrue: [^ 1].
	count := self itemsCount // self pageHeight.
	(self itemsCount \\ self pageHeight) > 0 
		ifTrue:[count := count + 1].
	^count! !

!ECMenuMorph methodsFor: 'paging' stamp: 'cmm 1/8/2007 21:09'!
pageCountString
	^ self itemsCount = 501
		ifTrue: [ 'more' ]
		ifFalse: [ self pageCount asString ]! !

!ECMenuMorph methodsFor: 'actions' stamp: 'bar 2/20/2006 17:24'!
pageDown
	self gotoPage: self currentPage + 1.
	self changed. ! !

!ECMenuMorph methodsFor: 'paging' stamp: 'bar 2/20/2006 17:53'!
pageHeight
	^pageHeight.! !

!ECMenuMorph methodsFor: 'actions' stamp: 'bar 2/20/2006 17:26'!
pageUp
	self gotoPage: self currentPage - 1.
	self changed. ! !

!ECMenuMorph methodsFor: 'drawing' stamp: 'MAD 10/8/2009 14:02'!
prepareRectForNextRow: aRectangle 
	^aRectangle translateBy: 0 @ self itemHeight! !

!ECMenuMorph methodsFor: 'title' stamp: 'bar 12/13/2004 14:16'!
removeTitle
	titleStringMorph
		ifNil: [^ self].
	self removeMorph: titleStringMorph owner. 
	titleStringMorph := nil! !

!ECMenuMorph methodsFor: 'drawing' stamp: 'bar 8/12/2005 23:12'!
selectColor: type
	^ self class selectColorFor: type! !

!ECMenuMorph methodsFor: 'drawing' stamp: 'bar 8/12/2005 22:43'!
selectFont: aSymbol 
	^ self class selectFontFor: aSymbol! !

!ECMenuMorph methodsFor: 'accessing' stamp: 'lr 7/4/2009 10:42'!
selected
	"Answer the value of selected"
	selected ifNil: [ selected := self firstVisible ].
	^ selected! !

!ECMenuMorph methodsFor: 'accessing' stamp: 'lr 7/4/2009 10:42'!
selected: aNumber 
	"Set the value of selected"
	context model notEmpty ifTrue: 
		[ ((1 to: self itemsCount) includes: aNumber) ifTrue: [ aNumber ~= selected ifTrue: [ selected := aNumber ] ] ]! !

!ECMenuMorph methodsFor: 'accessing' stamp: 'bar 3/3/2006 16:30'!
selectedEntry
	^ context model entries at: self selected! !

!ECMenuMorph methodsFor: 'initialization' stamp: 'bar 3/31/2006 09:34'!
setController: aECController position: aPoint 
	controller := aECController.
	context := controller context.
	self createTitle.
	self position: aPoint - (20 @ 0).
	self narrowCompletion
		ifTrue: [self openInWorld]. 
! !

!ECMenuMorph methodsFor: 'drawing' stamp: 'EduardoEscobar 1/10/2012 22:21'!
show
	"Make sure this morph is on-stage."
	| extent height |
	firstVisible := 1.
	height := self visibleItemsCount * self itemHeight.
	pageHeight := self height asInteger.
	self hasMessage
		ifTrue: [height := height + self class itemHeight].
	titleStringMorph
		ifNotNil: [height := height max: titleStringMorph width + 30].
	extent := self class itemWidth @ height.
	self extent: extent.
	self changed! !

!ECMenuMorph methodsFor: 'actions' stamp: 'lr 7/4/2009 10:42'!
showDetail
	detailMorph ifNotNil: [ ^ self browse ].
	self itemsCount isZero ifTrue: [ ^ self ].
	detailMorph := ECDetailMorph new.
	self addMorph: detailMorph.
	self updateDetail! !

!ECMenuMorph methodsFor: 'actions' stamp: 'bar 12/20/2004 23:21'!
switchToUntyped
	context switchToUntyped.
	self removeTitle; narrowCompletion; changed! !

!ECMenuMorph methodsFor: 'private' stamp: 'bar 3/3/2006 22:52'!
updateDetail
	detailMorph
		ifNil: [^ self].
	detailMorph
		entryDescription: (self selectedEntry descriptionWith: context).
	detailMorph position: detailPosition menuWidth: self width.
	detailMorph show! !

!ECMenuMorph methodsFor: 'private' stamp: 'pk 6/3/2004 16:31'!
visibleItemsCount.

	^ self lastVisible - self firstVisible + 1! !
